diff -ruN v515.orig/arch/arm/special/empeg_display.c v515/arch/arm/special/empeg_display.c
--- v515.orig/arch/arm/special/empeg_display.c	2008-06-04 10:17:32.000000000 -0700
+++ v515/arch/arm/special/empeg_display.c	2014-02-01 08:18:03.535192690 -0800
@@ -646,6 +646,7 @@
 // from hijack.c:
 //
 extern int empeg_on_dc_power;
+extern int hijack_hispeed_button_pic;
 extern void hijack_handle_display (struct display_dev *, unsigned char *);
 extern int hijack_ioctl (struct inode *, struct file *, unsigned int, unsigned long);
 
@@ -895,32 +896,62 @@
 	/* Disable FIQs too - might make the 2us delay too long */
 	save_flags_clif(flags);
 
-	/* Send 8 bits */
-	for(bit=7;bit>=0;bit--) {
-		/* Set line low */
-		GPCR=EMPEG_DISPLAYCONTROL;
+	/* If hijack_hispeed_button_pic is set, we double the */
+	/* transmission speed.  This is to work with a button */
+	/* PIC running at 40 MHz vs 20 MHz. */
+	if (hijack_hispeed_button_pic) {
+		/* Send 8 bits */
+		for(bit=7;bit>=0;bit--) {
+			/* Set line low */
+			GPCR=EMPEG_DISPLAYCONTROL;
+
+			/* Check the bit */
+			if (b&(1<<bit)) {
+				/* High - 7us of low */
+				udelay(7);
+			} else {
+				/* Low - 1us of low */
+				{ int a; for(a=0;a<22;a++); }
+			}
 
-		/* Check the bit */
-		if (b&(1<<bit)) {
-			/* High - 15us of low */
-			udelay(15);
-		} else {
-			/* Low - 2us of low */
-			//udelay(1);
-			{ int a; for(a=0;a<50;a++); }
+			/* Set line high */
+			GPSR=EMPEG_DISPLAYCONTROL;
+
+			/* Inter-bit delay */
+			udelay(7);
 		}
 
-		/* Set line high */
-		GPSR=EMPEG_DISPLAYCONTROL;
+		/* End of transmission, line low */
+		GPCR=EMPEG_DISPLAYCONTROL;
+		udelay( (sendcontrol_busy == 1) ? 2 : 20 );
+	} else {
+		/* Send 8 bits */
+		for(bit=7;bit>=0;bit--) {
+			/* Set line low */
+			GPCR=EMPEG_DISPLAYCONTROL;
+
+			/* Check the bit */
+			if (b&(1<<bit)) {
+				/* High - 15us of low */
+				udelay(15);
+			} else {
+				/* Low - 2us of low */
+				//udelay(1);
+				{ int a; for(a=0;a<50;a++); }
+			}
 
-		/* Inter-bit delay */
-	        udelay(15);
-	}
+			/* Set line high */
+			GPSR=EMPEG_DISPLAYCONTROL;
 
-	/* End of transmission, line low */
-	GPCR=EMPEG_DISPLAYCONTROL;
-	udelay( (sendcontrol_busy == 1) ? 5 : 40 );
+			/* Inter-bit delay */
+			udelay(15);
+		}
 
+		/* End of transmission, line low */
+		GPCR=EMPEG_DISPLAYCONTROL;
+		udelay( (sendcontrol_busy == 1) ? 5 : 40 );
+	}
+	
 	/* Reenable IRQs */
 	sendcontrol_busy = 0;
 	sendcontrol_timestamp = jiffies;
diff -ruN v515.orig/arch/arm/special/hijack.c v515/arch/arm/special/hijack.c
--- v515.orig/arch/arm/special/hijack.c	2011-07-20 06:22:58.000000000 -0700
+++ v515/arch/arm/special/hijack.c	2014-02-01 08:12:48.163697927 -0800
@@ -548,6 +548,7 @@
 //
 static	int hijack_buttonled_off_level;		// button brightness when player is "off"
 static	int hijack_buttonled_dim_level;		// when non-zero, button brightness when headlights are on
+	int hijack_hispeed_button_pic;		// 1 == change timing to work with a 40 MHz button PIC
 static	int hijack_dc_servers;			// 1 == allow kftpd/khttpd when on DC power
 static	int hijack_decimal_fidentry;		// 1 == fidentry uses base10 instead of hex
 	int hijack_disable_emplode;		// 1 == block TCP port 8300 (Emplode/Emptool)
@@ -665,6 +666,7 @@
 //===========================	==========================	=========		=======	===	================
 {"buttonled_off",		&hijack_buttonled_off_level,	1,			1,	0,	7},
 {"buttonled_dim",		&hijack_buttonled_dim_level,	0,			1,	0,	7},
+{"hispeed_button_pic",		&hijack_hispeed_button_pic,	0,			1,	0,	1},
 {"dc_servers",			&hijack_dc_servers,		0,			1,	0,	1},
 {"decimal_fidentry",		&hijack_decimal_fidentry,	0,			1,	0,	1},
 {"disable_emplode",		&hijack_disable_emplode,	0,			1,	0,	1},
